/*
 * Copyright 2004-2008, François Revol, <revol@free.fr>.
 * Distributed under the terms of the MIT License.
 */

#include <SupportDefs.h>
#include <TypeConstants.h>
#include "googlefs.h"

#define SZSTR(s) sizeof(s), s
#define SZTAB(s) sizeof(s), s

// #pragma mark - root folder icons

#if 0
/* old one */
const char google_icon_M[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1e, 0x1b, 0xd9, 0xd9, 0x1d, 0xff, 0xff, 
0xff, 0xff, 0x1d, 0x82, 0x82, 0x19, 0xff, 0xff, 0x1e, 0xd8, 0x64, 0x63, 0x63, 0xd8, 0x1b, 0xff, 
0xff, 0x1a, 0x2c, 0x2d, 0x2d, 0x2c, 0xc4, 0x1d, 0x62, 0x63, 0x1c, 0x3f, 0x1e, 0x63, 0xd8, 0x1d, 
0x1a, 0x2c, 0xca, 0x1a, 0x1d, 0x82, 0x2d, 0xa3, 0xd8, 0x62, 0x3f, 0x3f, 0x3f, 0x1e, 0xd8, 0x1a, 
0x82, 0x2d, 0x1a, 0x3f, 0x3f, 0x3f, 0xa3, 0x2d, 0xd8, 0x62, 0x0e, 0x1e, 0x3f, 0x1f, 0xd8, 0x62, 
0x82, 0x2d, 0x1d, 0x3f, 0x3f, 0x0f, 0x82, 0x2e, 0x63, 0x83, 0x0a, 0x1e, 0x3f, 0xfd, 0x64, 0x1b, 
0x19, 0x2c, 0x5a, 0x3f, 0x1e, 0x0b, 0xc4, 0xeb, 0x1a, 0x64, 0xd8, 0xd9, 0xd9, 0x64, 0x83, 0xff, 
0xff, 0xca, 0x2c, 0xa3, 0x5a, 0xc4, 0x2e, 0x82, 0xff, 0x1b, 0x83, 0x8a, 0x89, 0x17, 0x17, 0xff, 
0xff, 0x1a, 0xa9, 0x2e, 0x2e, 0xca, 0x82, 0x17, 0xff, 0xff, 0xff, 0x17, 0x17, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0x1a, 0x1a, 0x1a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};
const char google_icon_L[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1c, 0x1b, 0x1c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0x1c, 0x62, 0x63, 0xd8, 0xd8, 0xd8, 0x63, 0x62, 0x1d, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1e, 0x1e, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0x1a, 0xd8, 0xd8, 0xd8, 0xf8, 0xd8, 0xf8, 0xd8, 0xd8, 0x63, 0x1b, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0x1a, 0x18, 0xa3, 0xc4, 0xc4, 0xc4, 0xa9, 0x82, 0x1a, 0xff, 0xff, 0xff, 
0xff, 0x1a, 0xd8, 0xd8, 0x64, 0x84, 0x83, 0x63, 0x63, 0x84, 0xf8, 0xd8, 0x63, 0x1b, 0xff, 0xff, 
0xff, 0xff, 0xff, 0x1c, 0xa3, 0x2c, 0x2c, 0x2c, 0x2c, 0x2c, 0x2c, 0x2c, 0xc4, 0x1a, 0xff, 0xff, 
0x1c, 0x63, 0xf8, 0x84, 0x83, 0x1d, 0x1f, 0x3f, 0x1f, 0x1c, 0x63, 0x64, 0xd8, 0x63, 0x1d, 0xff, 
0xff, 0xff, 0x1c, 0xc4, 0x2c, 0x2c, 0x2d, 0x2e, 0x2e, 0x2e, 0x2e, 0x2c, 0x2c, 0x2c, 0x19, 0xff, 
0x62, 0xd8, 0x84, 0x63, 0x1f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1e, 0x63, 0xf8, 0xd8, 0x62, 0xff, 
0xff, 0x1a, 0xa3, 0x2c, 0x2d, 0x2e, 0xa3, 0x1a, 0x1c, 0x1a, 0x82, 0x2e, 0x2d, 0x2c, 0xc4, 0x1b, 
0x63, 0xf8, 0x84, 0x1d, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1b, 0xf8, 0xd8, 0x63, 0x1a, 
0xff, 0x18, 0x2c, 0x2d, 0x2f, 0x82, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1a, 0x2d, 0x2c, 0x2c, 0xa9, 
0xd8, 0x64, 0x83, 0x1f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1e, 0xd8, 0xd8, 0x83, 0x1a, 
0x1a, 0xa3, 0x2c, 0xeb, 0xa9, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x82, 0x2d, 0x2c, 0xca, 
0xd8, 0x64, 0x83, 0x1f, 0x19, 0x1b, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1f, 0xd8, 0xd8, 0x83, 0x1a, 
0x1a, 0xc4, 0x2c, 0x2f, 0x61, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1d, 0xc4, 0x2c, 0xeb, 
0xd8, 0xf8, 0x83, 0x15, 0x01, 0x03, 0x1b, 0x3f, 0x3f, 0x3f, 0x3f, 0x1e, 0xd8, 0xf8, 0x83, 0x1a, 
0x1a, 0xc4, 0x2c, 0x2f, 0x1c, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1c, 0x1b, 0x1e, 0xc4, 0x2d, 0x2f, 
0x83, 0xd8, 0x64, 0x0f, 0x00, 0x01, 0x19, 0x3f, 0x3f, 0x3f, 0x3f, 0xfd, 0xd8, 0x64, 0x14, 0x1a, 
0x1a, 0xc4, 0x2c, 0x2d, 0xda, 0x3f, 0x3f, 0x3f, 0x3f, 0x1c, 0x04, 0x02, 0x16, 0xc4, 0x2d, 0x2f, 
0x89, 0xf8, 0xd8, 0x63, 0x12, 0x15, 0x1f, 0x3f, 0x3f, 0x3f, 0xfe, 0xd8, 0xf8, 0x84, 0x18, 0xff, 
0x1a, 0xa9, 0x2c, 0x2c, 0x82, 0x3f, 0x3f, 0x3f, 0x3f, 0x1b, 0x02, 0x00, 0xa9, 0x2c, 0x2e, 0x2f, 
0x1a, 0x83, 0xf8, 0xf8, 0xd8, 0xfd, 0x1f, 0x1f, 0x1e, 0xfd, 0xd8, 0xf8, 0x84, 0x89, 0x1a, 0xff, 
0xff, 0x82, 0x2d, 0x2c, 0x2c, 0xda, 0x3f, 0x3f, 0x3f, 0x3f, 0x17, 0x13, 0xc4, 0x2d, 0xeb, 0xa9, 
0x1a, 0x1a, 0x83, 0x84, 0x64, 0xf8, 0xd8, 0xd8, 0xd8, 0xf8, 0xf8, 0x84, 0x89, 0x1b, 0xff, 0xff, 
0xff, 0x1a, 0xca, 0x2d, 0x2c, 0x2c, 0x5a, 0x1e, 0x3f, 0x1f, 0xda, 0xc4, 0x2c, 0xeb, 0x2f, 0x18, 
0xff, 0xff, 0x1a, 0x89, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x8a, 0x89, 0x1b, 0xff, 0xff, 0xff, 
0xff, 0xff, 0x19, 0xeb, 0x2d, 0x2c, 0x2c, 0x2c, 0xc4, 0x2c, 0x2c, 0x2c, 0x2e, 0x2f, 0x13, 0xff, 
0xff, 0xff, 0xff, 0x1a, 0x17, 0x89, 0x89, 0x8a, 0x89, 0x89, 0x18, 0x1a, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0x19, 0xca, 0x2e, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0xeb, 0x2f, 0x13, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1a, 0x1a, 0x1a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0x1c, 0xa9, 0xca, 0xeb, 0xeb, 0xeb, 0xca, 0xa9, 0x18, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1a, 0x1a, 0x18, 0x61, 0x1b, 0x1a, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};
#endif

// icons by ahwayakchih

const char google_icon_M[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1b, 0xd9, 0xd9, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0x82, 0x82, 0x19, 0xff, 0xff, 0xff, 0xd8, 0x64, 0x63, 0x63, 0xd8, 0xff, 0xff, 
0xff, 0xff, 0x2c, 0x2d, 0x2d, 0x2c, 0xc4, 0xff, 0x62, 0x63, 0x1c, 0x3f, 0x1e, 0x63, 0xd8, 0xff, 
0xff, 0x2c, 0xca, 0x1a, 0x1d, 0x82, 0x2d, 0xa3, 0xd8, 0x62, 0x3f, 0x3f, 0x3f, 0x1e, 0xd8, 0x1a, 
0x82, 0x2d, 0x1a, 0x3f, 0x3f, 0x3f, 0xa3, 0x2d, 0xd8, 0x62, 0x0e, 0x1e, 0x3f, 0x1f, 0xd8, 0x62, 
0x82, 0x2d, 0x1d, 0x3f, 0x3f, 0x0f, 0x82, 0x2e, 0x63, 0x83, 0x0a, 0x1e, 0x3f, 0xfd, 0x64, 0xff, 
0xff, 0x2c, 0x5a, 0x3f, 0x1e, 0x0b, 0xc4, 0xeb, 0xff, 0x64, 0xd8, 0xd9, 0xd9, 0x64, 0x83, 0xff, 
0xff, 0xca, 0x2c, 0xa3, 0x5a, 0xc4, 0x2e, 0x82, 0xff, 0xff, 0x83, 0x8a, 0x89, 0x17, 0xff, 0xff, 
0xff, 0xff, 0xa9, 0x2e, 0x2e, 0xca, 0x82, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};

const char google_icon_L[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x1b, 
0x09, 0x08, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 0x04, 0x1c, 
0x1b, 0x1c, 0x08, 0x09, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x1b, 0x09, 0x08, 
0x1c, 0x1c, 0x1b, 0x1c, 0x08, 0x09, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 0x04, 0x1c, 0x1b, 0x1c, 
0x08, 0x09, 0x1c, 0x1b, 0x1c, 0x1b, 0x09, 0x08, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x1b, 0x09, 0x08, 0x1c, 0x1c, 
0x1b, 0x1c, 0x08, 0x09, 0x1c, 0x1b, 0x1c, 0x1b, 0x09, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 0x04, 0x1c, 0x1b, 0x1c, 0x08, 0x09, 
0x1c, 0x1b, 0x1c, 0x1b, 0x09, 0x08, 0x1c, 0x1c, 0x1b, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x1b, 0x09, 0x08, 0x1c, 0x1c, 0x1b, 0x1c, 
0x08, 0x09, 0x1c, 0x1b, 0x1c, 0x1b, 0x09, 0x00, 0x1c, 0x00, 0xd9, 0x00, 0x00, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x04, 0x04, 0x1c, 0x1c, 0x1b, 0x09, 0x08, 0x1c, 0x1b, 
0x1c, 0x1c, 0x08, 0x09, 0x1b, 0x1c, 0x1c, 0x00, 0x15, 0x00, 0xd1, 0xd9, 0xd9, 0x00, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 0x1b, 0x1c, 0x09, 0x08, 
0x1c, 0x1b, 0x1c, 0x1c, 0x08, 0x00, 0x1c, 0x00, 0x15, 0x00, 0xd1, 0xd1, 0xd9, 0x00, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0x04, 0x04, 0x04, 0x1c, 0x3f, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 0x1b, 0x1c, 
0x09, 0x08, 0x1c, 0x1b, 0x1c, 0x00, 0x15, 0x00, 0x15, 0x00, 0xd1, 0xd9, 0xaa, 0x01, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0x04, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 0x3f, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 
0x1b, 0x1c, 0x09, 0x00, 0x1b, 0x00, 0x15, 0x00, 0x0f, 0x00, 0xd9, 0xaa, 0xaa, 0x00, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0x04, 0x3f, 0x3f, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 0x3f, 0x3f, 0x08, 0x09, 
0x1b, 0x1c, 0x1b, 0x00, 0x16, 0x00, 0x15, 0x00, 0x0f, 0xd9, 0xaa, 0xaa, 0xaa, 0x00, 0xff, 0xff, 
0xff, 0xff, 0xff, 0x00, 0x04, 0x3f, 0x1b, 0x1c, 0x3f, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 0x3f, 0x3f, 
0x08, 0x00, 0x1c, 0x00, 0x15, 0x00, 0x0f, 0x00, 0xd9, 0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0xff, 0xff, 
0xff, 0xff, 0x00, 0xd9, 0x04, 0x3f, 0x1b, 0x1c, 0x1b, 0x1c, 0x3f, 0x3f, 0x08, 0x09, 0x1b, 0x1c, 
0x3f, 0x00, 0x15, 0x00, 0x15, 0x00, 0x0f, 0xd9, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x0f, 0xff, 
0xff, 0x00, 0xd9, 0xd1, 0x04, 0x15, 0x1a, 0x19, 0x1c, 0x1b, 0x1c, 0x1c, 0x3f, 0x3f, 0x08, 0x00, 
0x1c, 0x00, 0x15, 0x00, 0x0f, 0x00, 0x63, 0xd8, 0xd8, 0xd8, 0x63, 0x62, 0xaa, 0x00, 0x0f, 0xff, 
0xff, 0x00, 0xd9, 0xd9, 0x04, 0x0f, 0x15, 0x15, 0x1a, 0x19, 0x1c, 0x1c, 0x1b, 0x1c, 0x3f, 0x00, 
0x15, 0x00, 0x15, 0x00, 0xd8, 0xd8, 0xd8, 0xf8, 0xd8, 0xf8, 0xd8, 0xd8, 0x63, 0x0f, 0x0f, 0xff, 
0xff, 0x00, 0x83, 0x83, 0xd9, 0xd9, 0x0f, 0xa3, 0xc4, 0xc4, 0xc4, 0xa9, 0x82, 0x1c, 0x1b, 0x00, 
0x15, 0x00, 0x0f, 0xd8, 0xd8, 0x64, 0x84, 0x83, 0x63, 0x63, 0x84, 0xf8, 0xd8, 0x63, 0xff, 0xff, 
0xff, 0x00, 0x83, 0x83, 0x83, 0xa3, 0x2c, 0x2c, 0x2c, 0x2c, 0x2c, 0x2c, 0x2c, 0xc4, 0x1c, 0x00, 
0x15, 0x00, 0x63, 0xf8, 0x84, 0x83, 0x1d, 0x3f, 0x3f, 0x3f, 0x1c, 0x63, 0x64, 0xd8, 0x63, 0xff, 
0xff, 0x00, 0x83, 0x83, 0xc4, 0x2c, 0x2c, 0x2d, 0xeb, 0xeb, 0xeb, 0xeb, 0x2c, 0x2c, 0x2c, 0x00, 
0x0f, 0x62, 0xd8, 0x84, 0x63, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1e, 0x63, 0xf8, 0xd8, 0x62, 
0xff, 0x00, 0x83, 0xa3, 0x2c, 0x2d, 0xeb, 0xa3, 0x1a, 0x1c, 0x1a, 0x82, 0xeb, 0x2d, 0x2c, 0xc4, 
0x0f, 0x63, 0xf8, 0x84, 0x1d, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1b, 0xf8, 0xd8, 0x63, 
0xff, 0x00, 0x83, 0x2c, 0x2d, 0x2f, 0x82, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1a, 0x2d, 0x2c, 0x2c, 
0xa9, 0xd8, 0x64, 0x83, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1e, 0xd8, 0xd8, 0x83, 
0xff, 0x00, 0xa3, 0x2c, 0xeb, 0xa9, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x82, 0x2d, 0x2c, 
0xca, 0xd8, 0x64, 0x83, 0x3f, 0x19, 0x1b, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0xd8, 0xd8, 0x83, 
0xff, 0x00, 0xc4, 0x2c, 0x2f, 0x19, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1d, 0xc4, 0x2c, 
0xeb, 0xd8, 0xf8, 0x83, 0x15, 0x01, 0x03, 0x1b, 0x3f, 0x3f, 0x3f, 0x3f, 0x1e, 0xd8, 0xf8, 0x83, 
0xff, 0x00, 0xc4, 0x2c, 0x2f, 0x1c, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x1c, 0x1b, 0x1e, 0xc4, 0x2d, 
0x2f, 0x83, 0xd8, 0x64, 0x0f, 0x00, 0x01, 0x19, 0x3f, 0x3f, 0x3f, 0x3f, 0xfd, 0xd8, 0x64, 0x14, 
0xff, 0x00, 0xc4, 0x2c, 0x2d, 0xda, 0x3f, 0x3f, 0x3f, 0x3f, 0x1c, 0x04, 0x02, 0x16, 0xc4, 0x2d, 
0x2f, 0x89, 0xf8, 0xd8, 0x63, 0x12, 0x15, 0x3f, 0x3f, 0x3f, 0x3f, 0xfe, 0xd8, 0xf8, 0x84, 0x14, 
0xff, 0xff, 0xa9, 0x2c, 0x2c, 0x82, 0x3f, 0x3f, 0x3f, 0x3f, 0x1b, 0x02, 0x00, 0xa9, 0x2c, 0xeb, 
0x2f, 0xaa, 0x83, 0xf8, 0xf8, 0xd8, 0xfd, 0x3f, 0x3f, 0x1e, 0xfd, 0xd8, 0xf8, 0x84, 0x89, 0xff, 
0xff, 0xff, 0x82, 0x2d, 0x2c, 0x2c, 0xda, 0x3f, 0x3f, 0x3f, 0x3f, 0x17, 0x13, 0xc4, 0x2d, 0xeb, 
0xa9, 0x00, 0x0f, 0x83, 0x84, 0x64, 0xf8, 0xd8, 0xd8, 0xd8, 0xf8, 0xf8, 0x84, 0x89, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xca, 0x2d, 0x2c, 0x2c, 0x5a, 0x1e, 0x3f, 0x3f, 0xda, 0xc4, 0x2c, 0xeb, 0x2f, 
0x00, 0x0f, 0x0f, 0xff, 0x89, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x8a, 0x89, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xeb, 0x2d, 0x2c, 0x2c, 0x2c, 0xc4, 0x2c, 0x2c, 0x2c, 0xeb, 0x2f, 0x00, 
0x0f, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x89, 0x89, 0x8a, 0x89, 0x89, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xca, 0xeb, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0xeb, 0x2f, 0x00, 0x0f, 
0x0e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xa9, 0xca, 0xeb, 0xeb, 0xeb, 0xca, 0xa9, 0x00, 0x0e, 0x0f, 
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};

const char google_icon_HVIF[] = {
	0x6e, 0x63, 0x69, 0x66, 0x12, 0x03, 0x99, 0x66, 0x33, 0x02, 0x00, 0x06,
	0x02, 0xb8, 0x7f, 0xa1, 0x3b, 0x71, 0xab, 0xbb, 0xc2, 0xa0, 0xb8, 0xba,
	0x5d, 0x4b, 0x18, 0xa2, 0x49, 0x9b, 0x1d, 0x00, 0xff, 0xcc, 0x99, 0xff,
	0xbd, 0x87, 0x52, 0x02, 0x00, 0x06, 0x02, 0x3b, 0x93, 0xe4, 0xb9, 0x93,
	0xe4, 0x39, 0x93, 0xe4, 0x3b, 0x93, 0xe4, 0x49, 0xa8, 0x8a, 0x47, 0x9b,
	0x06, 0x7c, 0x99, 0x66, 0x33, 0xc0, 0xb7, 0x87, 0x59, 0x02, 0x00, 0x06,
	0x02, 0x37, 0xb8, 0xfe, 0x38, 0x79, 0x61, 0xbb, 0x32, 0x4b, 0x3a, 0x67,
	0x9b, 0x4a, 0x8e, 0x15, 0x48, 0x6e, 0x2b, 0x00, 0xc8, 0x8c, 0x51, 0xff,
	0xff, 0xcc, 0x99, 0x02, 0x00, 0x16, 0x02, 0x38, 0x00, 0x17, 0xb9, 0xff,
	0xf7, 0x3a, 0x33, 0x30, 0x38, 0x33, 0x4f, 0x4a, 0x5e, 0xc6, 0x4a, 0x0f,
	0x65, 0x00, 0x67, 0xff, 0xff, 0x02, 0x00, 0x06, 0x02, 0xbb, 0x12, 0xa8,
	0x3a, 0x8f, 0x8c, 0xba, 0x8f, 0x8c, 0xbb, 0x12, 0xa8, 0x4b, 0x34, 0x46,
	0x4a, 0xf0, 0x63, 0x00, 0x99, 0x66, 0x33, 0xff, 0x68, 0x3a, 0x0e, 0x02,
	0x00, 0x06, 0x02, 0x3a, 0x0e, 0xd7, 0x3b, 0x6e, 0x12, 0xbb, 0x6e, 0x12,
	0x3a, 0x0e, 0xd7, 0x49, 0x97, 0xce, 0x48, 0x60, 0xc5, 0x00, 0xff, 0xe6,
	0xce, 0xff, 0xff, 0xcc, 0x99, 0x02, 0x00, 0x06, 0x02, 0x3a, 0x46, 0xde,
	0x3b, 0x49, 0xec, 0xbb, 0x49, 0xec, 0x3a, 0x46, 0xde, 0x4a, 0x60, 0x61,
	0x4a, 0x4d, 0xe6, 0x00, 0xad, 0x8a, 0x67, 0xff, 0x7e, 0x4e, 0x1e, 0x02,
	0x00, 0x06, 0x02, 0x38, 0x0d, 0x6f, 0x3b, 0xdd, 0xb9, 0xbb, 0xdd, 0xb9,
	0x38, 0x0d, 0x6f, 0x49, 0x75, 0xc0, 0x4a, 0x03, 0x71, 0x00, 0xee, 0xce,
	0xae, 0xff, 0xcc, 0x99, 0x66, 0x03, 0x01, 0x00, 0x00, 0x04, 0x00, 0x75,
	0x02, 0x00, 0x06, 0x03, 0x38, 0x00, 0x17, 0xb9, 0xff, 0xf7, 0x3a, 0x33,
	0x30, 0x38, 0x33, 0x4f, 0x4a, 0x5e, 0xc6, 0x4a, 0x0f, 0x65, 0x00, 0x4b,
	0x41, 0x16, 0xbd, 0xba, 0xb0, 0x88, 0xff, 0xfc, 0xf8, 0xe8, 0x03, 0x01,
	0x00, 0x00, 0x05, 0x00, 0x02, 0x01, 0x06, 0x02, 0x3b, 0x40, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x40, 0x00, 0x48, 0x60, 0x00, 0x4a,
	0xe0, 0x00, 0x00, 0xf3, 0xf8, 0xfa, 0xff, 0xbd, 0xdc, 0xe9, 0x03, 0x01,
	0x00, 0x00, 0x02, 0x01, 0x06, 0x03, 0x3d, 0x04, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x3d, 0x04, 0x00, 0x47, 0x58, 0x00, 0x4a, 0x50, 0x00,
	0x00, 0xff, 0xff, 0xff, 0x7c, 0xff, 0x06, 0x06, 0xff, 0x3c, 0x25, 0x25,
	0x02, 0x01, 0x06, 0x03, 0x3d, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x3d, 0x04, 0x00, 0x47, 0x58, 0x00, 0x4a, 0x50, 0x00, 0x00, 0xff,
	0xff, 0xff, 0x7c, 0xff, 0xea, 0x05, 0xff, 0x3c, 0x25, 0x25, 0x10, 0x0a,
	0x04, 0x2c, 0x40, 0x3c, 0x47, 0x3c, 0x4c, 0x2c, 0x44, 0x0a, 0x06, 0x2a,
	0x40, 0x2a, 0x4c, 0x42, 0x58, 0x5a, 0x40, 0x5a, 0x36, 0x42, 0x2c, 0x0a,
	0x04, 0x2a, 0x40, 0x42, 0x4c, 0x5a, 0x36, 0x42, 0x2c, 0x0a, 0x06, 0xc6,
	0x88, 0xbd, 0xf6, 0xc8, 0xa6, 0xbc, 0x05, 0xc0, 0xaf, 0xb8, 0xb3, 0xb8,
	0x6e, 0xbf, 0x95, 0xba, 0x6c, 0xc0, 0x94, 0x42, 0x34, 0x0a, 0x04, 0xc6,
	0x88, 0xbd, 0xf6, 0xc0, 0x69, 0xc3, 0x92, 0xba, 0x6c, 0xc0, 0x94, 0x42,
	0x34, 0x0a, 0x04, 0x42, 0x58, 0x5a, 0x40, 0x5a, 0x36, 0x42, 0x4c, 0x0a,
	0x06, 0x26, 0x32, 0x26, 0x4e, 0x42, 0x5c, 0x44, 0x5a, 0x44, 0x3c, 0x28,
	0x30, 0x0a, 0x04, 0x26, 0x32, 0x42, 0x3e, 0x44, 0x3c, 0x28, 0x30, 0x0a,
	0x04, 0x42, 0x5c, 0x44, 0x5a, 0x44, 0x3c, 0x42, 0x3e, 0x0a, 0x04, 0x26,
	0x4e, 0x42, 0x5c, 0x42, 0x3e, 0x26, 0x32, 0x0a, 0x07, 0x42, 0x5e, 0x54,
	0x5e, 0x56, 0x5c, 0x4b, 0x57, 0x62, 0x40, 0x5c, 0x3e, 0x42, 0x3e, 0x0a,
	0x09, 0x58, 0x54, 0x50, 0x50, 0x5c, 0x50, 0x54, 0x4c, 0x60, 0x4c, 0x58,
	0x48, 0x64, 0x48, 0x58, 0x42, 0x46, 0x54, 0x0a, 0x05, 0x46, 0x45, 0x46,
	0x36, 0x36, 0x2f, 0x36, 0x43, 0xc0, 0x58, 0xc3, 0x3c, 0x0a, 0x0a, 0x23,
	0x2f, 0x2d, 0x49, 0x4a, 0x5b, 0x5c, 0x2c, 0x50, 0x2a, 0x4c, 0x2c, 0x3a,
	0x28, 0x38, 0x2d, 0x30, 0x2b, 0xb9, 0x57, 0xba, 0xa7, 0x02, 0x04, 0x32,
	0x46, 0xbb, 0xee, 0x46, 0xb8, 0x69, 0x46, 0x2a, 0x4e, 0x2a, 0xc3, 0x91,
	0x2a, 0xc7, 0x16, 0x32, 0x56, 0xb8, 0x69, 0x56, 0xbb, 0xee, 0x56, 0x3a,
	0x4e, 0x3a, 0xc7, 0x16, 0x3a, 0xc3, 0x91, 0x08, 0x04, 0x23, 0xb3, 0xe5,
	0xcb, 0x34, 0xb4, 0x18, 0xcb, 0x81, 0xcb, 0x5a, 0x24, 0xcb, 0xa7, 0x1a,
	0x0a, 0x0a, 0x02, 0x0a, 0x0b, 0x20, 0x1c, 0x20, 0x0a, 0x09, 0x01, 0x01,
	0x30, 0x1c, 0x20, 0x01, 0x17, 0x84, 0x10, 0x04, 0x0a, 0x01, 0x01, 0x02,
	0x20, 0x1c, 0x20, 0x0a, 0x02, 0x01, 0x03, 0x20, 0x1c, 0x20, 0x0a, 0x03,
	0x01, 0x04, 0x20, 0x1c, 0x20, 0x0a, 0x05, 0x01, 0x05, 0x20, 0x1c, 0x20,
	0x0a, 0x0c, 0x01, 0x0c, 0x30, 0x28, 0x14, 0x01, 0x17, 0x84, 0x10, 0x04,
	0x0a, 0x0b, 0x01, 0x0c, 0x20, 0x28, 0x14, 0x0a, 0x0c, 0x01, 0x0c, 0x30,
	0x24, 0x18, 0x01, 0x17, 0x84, 0x10, 0x04, 0x0a, 0x0b, 0x01, 0x0c, 0x20,
	0x24, 0x18, 0x0a, 0x0c, 0x01, 0x0c, 0x30, 0x20, 0x1c, 0x01, 0x17, 0x84,
	0x10, 0x04, 0x0a, 0x0b, 0x01, 0x0c, 0x20, 0x20, 0x1c, 0x0a, 0x0c, 0x01,
	0x0c, 0x30, 0x1c, 0x20, 0x01, 0x17, 0x84, 0x10, 0x04, 0x0a, 0x0b, 0x01,
	0x0c, 0x20, 0x1c, 0x20, 0x0a, 0x09, 0x01, 0x06, 0x30, 0x1c, 0x20, 0x01,
	0x17, 0x84, 0x00, 0x04, 0x0a, 0x06, 0x01, 0x07, 0x20, 0x1c, 0x20, 0x0a,
	0x07, 0x01, 0x08, 0x20, 0x1c, 0x20, 0x0a, 0x08, 0x01, 0x09, 0x20, 0x1c,
	0x20, 0x0a, 0x00, 0x01, 0x00, 0x20, 0x1e, 0x24, 0x0a, 0x0c, 0x01, 0x00,
	0x20, 0x1c, 0x20, 0x0a, 0x10, 0x01, 0x0e, 0x30, 0xb0, 0x42, 0xb5, 0xbd,
	0x01, 0x17, 0x84, 0x00, 0x04, 0x0a, 0x0e, 0x01, 0x0e, 0x20, 0xb0, 0x42,
	0xb5, 0xbd, 0x0a, 0x0f, 0x01, 0x0e, 0x02, 0x3c, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x46, 0xe8, 0x00, 0x4a, 0xb6,
	0x00, 0x0a, 0x11, 0x01, 0x0e, 0x30, 0xb7, 0xfb, 0xb3, 0x8c, 0x01, 0x17,
	0x84, 0x00, 0x04, 0x0a, 0x0e, 0x01, 0x0e, 0x20, 0xb7, 0xfb, 0xb3, 0x8c,
	0x0a, 0x0f, 0x01, 0x0e, 0x02, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x3c, 0x00, 0x00, 0x48, 0xc0, 0x00, 0x4a, 0x6e, 0x00
};

const char google_icon_SVG[] = {
	0x54, 0x1f, 0x00, 0x00, 0x78, 0xda, 0xed, 0x98, 0x5d, 0x6f, 0xdb, 0x36, 0x14, 0x86, 0xef, 0xf3,
	0x2b, 0x08, 0xe5, 0xa6, 0x06, 0x6c, 0x86, 0x3c, 0xfc, 0x10, 0x95, 0xda, 0x29, 0xb0, 0x00, 0xab,
	0x2f, 0x54, 0x0c, 0xd8, 0x1a, 0xdf, 0x2b, 0x32, 0xed, 0x08, 0x73, 0x24, 0x4f, 0x72, 0xb2, 0xb8,
	0xbf, 0x7e, 0x87, 0xfa, 0x48, 0x6b, 0xc7, 0xcd, 0x58, 0xc3, 0xf5, 0x12, 0x2c, 0x32, 0x20, 0x91,
	0x32, 0x25, 0x91, 0xef, 0x79, 0x78, 0xc8, 0x73, 0x86, 0x1f, 0x1e, 0x6e, 0x17, 0xe4, 0xde, 0x96,
	0x55, 0x56, 0xe4, 0xa3, 0x80, 0x53, 0x16, 0x10, 0x9b, 0xa7, 0xc5, 0x34, 0xcb, 0xe7, 0xa3, 0xe0,
	0xea, 0xf3, 0xaf, 0x03, 0x13, 0x90, 0x6a, 0x95, 0xe4, 0xd3, 0x64, 0x51, 0xe4, 0x76, 0x14, 0xac,
	0x6d, 0x15, 0x7c, 0xb8, 0x38, 0x19, 0x56, 0xf7, 0x73, 0xf2, 0x77, 0x36, 0x5d, 0xdd, 0x8c, 0x02,
	0x2d, 0x03, 0x72, 0x63, 0xb3, 0xf9, 0xcd, 0xaa, 0x29, 0xa7, 0xc5, 0xa2, 0x28, 0x07, 0x59, 0xbe,
	0xb2, 0xe5, 0xb2, 0x58, 0x24, 0xab, 0xfa, 0xcd, 0x8b, 0x2c, 0xb7, 0x49, 0xf9, 0xfb, 0xc7, 0x5f,
	0x82, 0x8b, 0x13, 0x32, 0x9c, 0xe3, 0x89, 0x0c, 0x97, 0xc9, 0xea, 0x06, 0x5f, 0xbe, 0x5e, 0xe0,
	0x7b, 0x67, 0xd9, 0x62, 0x71, 0x7e, 0xca, 0xea, 0xe3, 0x3d, 0x71, 0xb5, 0x41, 0xb1, 0x4c, 0xd2,
	0x6c, 0xb5, 0x3e, 0x67, 0x54, 0x2a, 0x63, 0x02, 0x7c, 0xa2, 0x39, 0xa6, 0xa3, 0xe0, 0x93, 0x90,
	0x44, 0xc3, 0x58, 0x41, 0xac, 0xb0, 0xc0, 0x62, 0x29, 0x88, 0x52, 0xb1, 0xd6, 0x44, 0x40, 0xac,
	0x19, 0x11, 0x6c, 0x2c, 0xe4, 0x44, 0xc3, 0x97, 0xc7, 0x67, 0xf0, 0xf8, 0xa4, 0x34, 0xc1, 0x07,
	0xa4, 0x21, 0xd2, 0x8c, 0xf1, 0x19, 0x05, 0x44, 0xca, 0xb1, 0x96, 0x31, 0xde, 0x97, 0x6c, 0xac,
	0x8d, 0x2b, 0x08, 0x19, 0x0b, 0x83, 0xcd, 0xc6, 0x4a, 0x7f, 0xf9, 0xfa, 0xc5, 0x55, 0x99, 0xe4,
	0xd5, 0xac, 0x28, 0x6f, 0x47, 0xc1, 0x6d, 0xb2, 0x2a, 0xb3, 0x87, 0x77, 0xbc, 0xcf, 0xf0, 0xc7,
	0xfb, 0x03, 0xd9, 0x67, 0x3d, 0xd7, 0xf0, 0x6c, 0xf7, 0x88, 0x72, 0x14, 0xed, 0x3d, 0xde, 0x29,
	0x8b, 0x3f, 0x2d, 0x0e, 0x8f, 0x37, 0xc3, 0x6b, 0xea, 0x83, 0x5a, 0xbf, 0x73, 0xf9, 0x58, 0x77,
	0x1a, 0xa5, 0xc9, 0xf2, 0xbc, 0xfa, 0xeb, 0x2e, 0x29, 0xed, 0xe6, 0x80, 0x39, 0x8e, 0x0a, 0x26,
	0x12, 0xbb, 0x27, 0x89, 0xd2, 0xb1, 0x32, 0xae, 0x0a, 0xe0, 0xaa, 0x1c, 0xe2, 0xfa, 0xdf, 0x7d,
	0x3a, 0xdc, 0x98, 0xe5, 0x63, 0x99, 0x4c, 0x33, 0x9b, 0xaf, 0x48, 0x86, 0x9f, 0x9a, 0xb7, 0x15,
	0x24, 0xa1, 0x2b, 0x5e, 0xe5, 0xd9, 0xaa, 0x1a, 0x05, 0x77, 0x95, 0x2d, 0xff, 0x40, 0xa3, 0xd8,
	0xdf, 0xf2, 0xab, 0xca, 0x06, 0xe4, 0x81, 0xa3, 0xc1, 0x23, 0xaa, 0xc2, 0x80, 0xac, 0xb1, 0x08,
	0x8c, 0x2a, 0xc0, 0xbb, 0x30, 0x0a, 0x14, 0xde, 0x45, 0x70, 0xd6, 0x58, 0x94, 0x86, 0xb2, 0xd0,
	0x19, 0x1d, 0xbf, 0x56, 0xad, 0x8a, 0x25, 0x29, 0x66, 0xb3, 0xca, 0x22, 0x2a, 0xcc, 0x81, 0x55,
	0x2c, 0x07, 0x35, 0x2e, 0xa3, 0xe0, 0x74, 0x36, 0x4b, 0xd3, 0x28, 0x0a, 0xce, 0x76, 0x34, 0xe5,
	0x5b, 0x4d, 0xaf, 0xa7, 0x26, 0xc4, 0x4f, 0x35, 0x43, 0x38, 0xdb, 0x1c, 0xc3, 0x6e, 0x3b, 0xdc,
	0x95, 0x8b, 0x77, 0xa7, 0x8f, 0x23, 0xeb, 0xed, 0xd0, 0xd6, 0x29, 0x89, 0xf2, 0xa2, 0xb0, 0x3f,
	0x55, 0x55, 0xee, 0xa5, 0x6a, 0x48, 0x4d, 0xa3, 0x69, 0x48, 0x41, 0x37, 0x92, 0x0a, 0x4d, 0x25,
	0x34, 0x92, 0x0e, 0x42, 0xca, 0xe4, 0x4e, 0x49, 0xa9, 0x34, 0x46, 0x6f, 0x89, 0x15, 0x45, 0x5a,
	0x0b, 0xb1, 0x53, 0x57, 0x46, 0x43, 0x25, 0xc2, 0x6d, 0x71, 0x43, 0x14, 0x37, 0xda, 0x5b, 0x5c,
	0xbe, 0x25, 0xae, 0x8c, 0x28, 0x03, 0x02, 0x21, 0x55, 0x1c, 0x27, 0x2b, 0x15, 0x02, 0xf5, 0xa5,
	0xda, 0x71, 0x4c, 0x9d, 0xca, 0x78, 0xe6, 0x31, 0x17, 0x54, 0x03, 0x11, 0x1c, 0x51, 0x8a, 0xb9,
	0xa1, 0x5a, 0xe0, 0x3c, 0xa4, 0xcc, 0x38, 0x33, 0x00, 0x4e, 0xee, 0xaf, 0x6f, 0x38, 0xb0, 0x31,
	0xc0, 0xcb, 0x18, 0xf8, 0xfd, 0x48, 0x36, 0xe6, 0x90, 0xd4, 0x84, 0x2d, 0xe1, 0x21, 0x15, 0x2d,
	0xe1, 0x38, 0x86, 0xd0, 0x8b, 0xf0, 0xd4, 0x98, 0x54, 0x71, 0x2f, 0xc2, 0xbf, 0x9d, 0x0c, 0x7b,
	0x18, 0x01, 0x9e, 0x31, 0x82, 0x40, 0xb1, 0xd1, 0xe3, 0xa1, 0xd8, 0xd1, 0x51, 0xc5, 0x16, 0x7e,
	0xe4, 0x8b, 0x0e, 0x7d, 0xd7, 0x93, 0x56, 0x6c, 0x2c, 0x02, 0x6f, 0xc4, 0x76, 0xfe, 0x46, 0xf9,
	0x88, 0xfd, 0x0c, 0xf6, 0xdb, 0x62, 0x6b, 0x23, 0x12, 0x66, 0xf7, 0x16, 0x5b, 0xf4, 0x9e, 0xac,
	0x4d, 0x5b, 0x1e, 0x5a, 0xca, 0xc9, 0x4b, 0x5b, 0x4f, 0x70, 0x95, 0x13, 0xa1, 0xeb, 0x1e, 0x00,
	0xe1, 0x6a, 0x22, 0x94, 0xe3, 0x42, 0x46, 0xb8, 0x12, 0xd2, 0xb0, 0x5e, 0x03, 0x45, 0xe8, 0xd5,
	0x61, 0xd3, 0x1f, 0x70, 0xf0, 0x03, 0x40, 0x7a, 0x01, 0x00, 0x8a, 0x72, 0x68, 0x08, 0x40, 0x97,
	0xa7, 0x3a, 0xef, 0x27, 0x9a, 0xbb, 0xd0, 0x2c, 0x33, 0xda, 0x87, 0x00, 0x79, 0x2d, 0x39, 0xd7,
	0xdf, 0x73, 0x7c, 0x12, 0xe4, 0xb6, 0xe3, 0x4b, 0xae, 0x19, 0xee, 0x33, 0xbc, 0xa6, 0x67, 0x3a,
	0x33, 0xd6, 0xec, 0x4d, 0x8c, 0xec, 0x1d, 0xc7, 0x18, 0x2f, 0x1f, 0x1f, 0xd9, 0x1f, 0x18, 0x3f,
	0x7a, 0xd4, 0x1b, 0x3d, 0x9d, 0x12, 0xbd, 0xa3, 0xd8, 0xe2, 0xe5, 0xc3, 0xc3, 0xd0, 0x5d, 0xfa,
	0xc1, 0xa3, 0xdf, 0xe0, 0xe9, 0x94, 0xe8, 0x1d, 0xc5, 0x16, 0x2f, 0x1f, 0x1e, 0xff, 0x8d, 0x4b,
	0xf8, 0x06, 0x4f, 0xa7, 0x44, 0xef, 0x28, 0xb6, 0xd8, 0x0b, 0x9e, 0xcd, 0x9e, 0x69, 0xc2, 0xcd,
	0x44, 0x6a, 0xb7, 0xf9, 0xc2, 0x50, 0x5f, 0x60, 0xe4, 0x6f, 0x26, 0x60, 0x62, 0x43, 0xb8, 0x8e,
	0xdd, 0x7f, 0x07, 0x46, 0xc4, 0x78, 0x21, 0x82, 0xfb, 0x6c, 0x10, 0x0d, 0x22, 0x03, 0xa0, 0x51,
	0x17, 0x2b, 0x33, 0xaa, 0xa3, 0x16, 0x11, 0x89, 0xdb, 0x6e, 0xbf, 0x58, 0xd9, 0xea, 0xd4, 0x1e,
	0x23, 0x92, 0x30, 0xbd, 0xa7, 0xc2, 0x3a, 0x55, 0x45, 0xad, 0xea, 0x4f, 0x94, 0x34, 0xf2, 0x8b,
	0xcd, 0xa0, 0x0e, 0x12, 0x9c, 0xa4, 0x18, 0x86, 0xb5, 0x93, 0x4e, 0x33, 0x0a, 0x5d, 0xf6, 0x81,
	0xd1, 0xc8, 0x4b, 0xd1, 0x64, 0x6a, 0x12, 0x1d, 0x7a, 0x29, 0x1a, 0x5a, 0x69, 0xf9, 0xfe, 0xe1,
	0x42, 0xf4, 0x34, 0x5c, 0xf8, 0x16, 0xd1, 0x5a, 0xdb, 0x89, 0x66, 0x87, 0xce, 0x3b, 0xf8, 0xa5,
	0x73, 0x04, 0x06, 0x5d, 0x2d, 0xa2, 0xdc, 0x85, 0xe9, 0x6d, 0xfc, 0x15, 0x52, 0xe7, 0x75, 0x6a,
	0x41, 0x85, 0xcb, 0xf7, 0x78, 0x08, 0x6a, 0x6d, 0x6a, 0x13, 0x3f, 0x44, 0x1d, 0xa0, 0x5a, 0xef,
	0x9f, 0x71, 0x60, 0x4f, 0x18, 0xed, 0x66, 0xfe, 0x04, 0x31, 0x6d, 0x5d, 0xc1, 0x41, 0x1c, 0x51,
	0x17, 0x55, 0x6e, 0xa6, 0x8f, 0xc0, 0xa5, 0x8f, 0x00, 0xbd, 0x5d, 0xe4, 0x12, 0x74, 0xae, 0xaa,
	0x27, 0xbe, 0x89, 0x23, 0xe8, 0x3f, 0xbb, 0x6c, 0xb6, 0xce, 0xee, 0x80, 0x1f, 0xdc, 0x1c, 0xa1,
	0x93, 0x30, 0x59, 0xec, 0x26, 0xe6, 0xdf, 0x53, 0x55, 0xe9, 0x43, 0x6d, 0xf7, 0x74, 0x5d, 0x5f,
	0xca, 0x26, 0xfd, 0xdb, 0x3d, 0xf3, 0xf9, 0x49, 0x1f, 0x18, 0x15, 0xa1, 0x8e, 0xea, 0x8e, 0xb4,
	0x45, 0x2e, 0xf0, 0xaa, 0xfa, 0x02, 0x17, 0x16, 0x2f, 0xaf, 0xe7, 0x8e, 0xef, 0x2c, 0x8c, 0xd2,
	0x18, 0x78, 0xd2, 0x9e, 0x69, 0xa6, 0xbd, 0x10, 0x14, 0x29, 0x28, 0x50, 0x1d, 0x82, 0x9b, 0xaa,
	0x78, 0xac, 0x49, 0x9b, 0x3c, 0xf2, 0xde, 0xf3, 0x8b, 0x13, 0x47, 0xcb, 0x99, 0x4b, 0x1c, 0xbb,
	0xcb, 0x11, 0xa0, 0xff, 0x64, 0x75, 0x36, 0xa6, 0x29, 0xe8, 0x4b, 0x3c, 0xe3, 0x92, 0x20, 0x39,
	0x69, 0x1a, 0x28, 0x89, 0xfc, 0xe2, 0xf9, 0x12, 0xc0, 0xdd, 0xc4, 0x2a, 0xe8, 0xb6, 0x01, 0x38,
	0xd0, 0x2f, 0x41, 0xb7, 0x8f, 0x37, 0x0d, 0xdc, 0x0b, 0xdd, 0x6b, 0xfd, 0x68, 0xd0, 0xd4, 0xa0,
	0xfe, 0xf5, 0xd9, 0x93, 0x0a, 0x38, 0x3c, 0x15, 0xc0, 0x04, 0x6f, 0xa9, 0xa8, 0x8b, 0x3c, 0xea,
	0x4b, 0xed, 0x47, 0x84, 0x98, 0x99, 0x59, 0xe2, 0x99, 0x33, 0x9e, 0xa6, 0x36, 0xfa, 0x11, 0x0b,
	0x6f, 0x1a, 0x75, 0x3b, 0xa5, 0xf6, 0xe2, 0x8d, 0xe8, 0xe9, 0x4b, 0xfe, 0xf3, 0x61, 0xa0, 0xd1,
	0x55, 0x67, 0x7d, 0xd5, 0xe7, 0x9c, 0x6a, 0xbc, 0xc8, 0xda, 0x31, 0x78, 0x22, 0x29, 0x5e, 0xbf,
	0xa3, 0xb2, 0x09, 0x53, 0xc7, 0x77, 0x54, 0xe2, 0xd5, 0x38, 0x2a, 0xdc, 0x8c, 0x20, 0x1b, 0x3f,
	0xc0, 0x84, 0xfc, 0x9f, 0xba, 0x29, 0xd9, 0x7b, 0x55, 0x26, 0x7c, 0x9d, 0x4e, 0x0a, 0xa0, 0x2f,
	0xcc, 0x86, 0xbb, 0x1d, 0x9e, 0xcd, 0x2f, 0x4e, 0x86, 0x67, 0xd5, 0x3d, 0x5e, 0xfe, 0x01, 0xe0,
	0x04, 0x88, 0xf2
};

// #pragma mark - root folder attribute list
//0x6949434F           7  "BEOS:D:STD_ICON"                   49 44 58 5A 05 53 00
uint8 root_folder_attrs_1[] = { 0x49, 0x44, 0x58, 0x5A, 0x05, 0x53, 0x00 }; // needed for SVG icons in Zeta...
uint64 root_folder_attrs_2 = 0xdeadbeef50385038LL; // volume id, just in case

struct attr_entry root_folder_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-vnd.Be-directory") },
{ "BEOS:M:STD_ICON", 'MICN', 16*16, (char *)google_icon_M },
{ "BEOS:L:STD_ICON", 'ICON', 32*32, (char *)google_icon_L },
{ "BEOS:V:STD_ICON", 'zICO', sizeof(google_icon_SVG), google_icon_SVG },
{ "BEOS:D:STD_ICON", 0x6949434F, sizeof(root_folder_attrs_1), &root_folder_attrs_1 },
{ "BEOS:ICON", 'VICN', sizeof(google_icon_HVIF), google_icon_HVIF },
//{ "BEOS:EMBLEMS", 'CSTR', SZSTR("palm") },
{ "be:volume_id", B_UINT64_TYPE, sizeof(root_folder_attrs_2), &root_folder_attrs_2 },
{ NULL, 0, 0, NULL } /* end of list */
};

static uint8 folders_attrs_1[] = {
 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x54, 0x69, 0x74, 0x6c,
 0x65, 0x00, 0x00, 0x00, 0x20, 0x42, 0x00, 0x00, 0x02, 0x43, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00,
 0x00, 0x00, 0x4d, 0x45, 0x54, 0x41, 0x3a, 0x74, 0x69, 0x74, 0x6c, 0x65, 0x00, 0x52, 0x7d, 0xfb,
 0x77, 0x52, 0x54, 0x53, 0x43, 0x00, 0x01, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x03,
 0x00, 0x00, 0x00, 0x55, 0x52, 0x4c, 0x00, 0x00, 0x00, 0x39, 0x43, 0x00, 0x00, 0x2a, 0x43, 0x00,
 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x4d, 0x45, 0x54, 0x41, 0x3a, 0x75, 0x72, 0x6c, 0x00,
 0x52, 0x54, 0x5b, 0xe3, 0x52, 0x54, 0x53, 0x43, 0x00, 0x01, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00,
 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x4b, 0x65, 0x79, 0x77, 0x6f, 0x72, 0x64, 0x73, 0x00, 0x00,
 0x00, 0xb9, 0x43, 0x00, 0x00, 0x02, 0x43, 0x00, 0x00, 0x00, 0x00, 0x09, 0x00, 0x00, 0x00, 0x4d,
 0x45, 0x54, 0x41, 0x3a, 0x6b, 0x65, 0x79, 0x77, 0x00, 0x52, 0xdc, 0xf3, 0xdb, 0x52, 0x54, 0x53,
 0x43, 0x00, 0x01, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x4d,
 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x00, 0x00, 0xc0, 0x00, 0x44, 0x00, 0x00, 0x16, 0x43,
 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x5f, 0x73, 0x74, 0x61, 0x74, 0x2f, 0x6d, 0x6f,
 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x00, 0x45, 0x6d, 0x4b, 0x5d, 0x45, 0x4d, 0x49, 0x54, 0x01,
 0x00, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x47, 0x6f, 0x6f,
 0x67, 0x6c, 0x65, 0x20, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x00, 0x00, 0x00, 0x2a, 0x44, 0x00, 0x00,
 0xa0, 0x41, 0x01, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x47, 0x4f, 0x4f, 0x47, 0x4c, 0x45,
 0x3a, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x00, 0x47, 0xde, 0xef, 0xfc, 0x47, 0x4e, 0x4f, 0x4c, 0x00,
 0x01 };
static uint8 folders_attrs_2[] = {
 0x52, 0xf5, 0x5e, 0x6f, 0x0a, 0x00, 0x00, 0x00, 0x74, 0x73, 0x6c, 0x54, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x47, 0xde, 0xef, 0xfc, 0x47, 0x4e, 0x4f, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x01 };
struct attr_entry folders_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-vnd.Be-directory") },
{ "_trk/columns_le", 'RAWT', SZTAB(folders_attrs_1) },
{ "_trk/viewstate_le", 'RAWT', SZTAB(folders_attrs_2) },
{ "", 'RAWT', SZTAB(folders_attrs_2) },
{ NULL, 0, 0, NULL } /* end of list */
};

struct attr_entry bookmark_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-vnd.Be-bookmark") },
{ NULL, 0, 0, NULL } /* end of list */
};

/* for debugging */
//static int32 fake_bm_attr_1 = 1;
struct attr_entry fake_bookmark_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-vnd.Be-bookmark") },
{ "META:title", 'CSTR', SZSTR("Plop!") },
{ "META:url", 'CSTR', SZSTR("http://127.0.0.1/") },
{ "META:keyw", 'CSTR', SZSTR("plop") },
//{ "GOOGLE:order", 'LONG', sizeof(int32), &fake_bm_attr_1 },
{ NULL, 0, 0, NULL } /* end of list */
};

static uint8 template_1_attrs_1 = 1;
static int32 template_1_attrs_2 = 1;
static uint8 template_1_attrs_3[] = {
 0x31, 0x42, 0x4F, 0x46, 0x01, 0x00, 0x00, 0x98, 0x98, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x01, 0x0F, 0x47, 0x4E, 0x4F, 0x4C, 0x04, 0x0C, 0x63, 0x72, 0x65, 0x61, 0x74, 0x69, 0x6F, 0x6E,
 0x44, 0x61, 0x74, 0x65, 0x51, 0xEA, 0xC7, 0x41, 0x0F, 0x47, 0x4E, 0x4C, 0x4C, 0x08, 0x08, 0x63,
 0x61, 0x70, 0x61, 0x63, 0x69, 0x74, 0x79, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0B,
 0x52, 0x54, 0x53, 0x43, 0x08, 0x0A, 0x64, 0x65, 0x76, 0x69, 0x63, 0x65, 0x4E, 0x61, 0x6D, 0x65,
 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x41, 0x0B, 0x52, 0x54, 0x53, 0x43, 0x10, 0x0A, 0x76,
 0x6F, 0x6C, 0x75, 0x6D, 0x65, 0x4E, 0x61, 0x6D, 0x65, 0x07, 0x00, 0x00, 0x00, 0x47, 0x6F, 0x6F,
 0x67, 0x6C, 0x65, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0B, 0x52, 0x54, 0x53, 0x43, 0x10, 0x07,
 0x66, 0x73, 0x68, 0x4E, 0x61, 0x6D, 0x65, 0x09, 0x00, 0x00, 0x00, 0x67, 0x6F, 0x6F, 0x67, 0x6C,
 0x65, 0x66, 0x73, 0x00, 0x00, 0x00, 0x00, 0x00 };
static int32 template_1_attrs_4 = 0x4662796E;
static uint8 template_1_attrs_5[] = {
 0x00, 0x00, 0x06, 0xEC, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00 };
static int32 template_1_attrs_6 = 0x00000027;
static int32 template_1_attrs_7 = 0x00000000;
static uint8 template_1_attrs_8[] = {
 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x82, 0x43, 0x00, 0x00, 0xA0, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0xE0, 0x9F, 0x44, 0x00, 0xC0, 0x7F, 0x44, 0xFF, 0xFF, 0xFF, 0xFF };
static uint8 template_1_attrs_9[] = {
 0x00, 0x00, 0x00, 0x00, 0x58, 0x10, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x44, 
 0x00, 0x00, 0x0c, 0x44 };
/*static uint8 template_1_attrs_10[] = {
 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x54, 0x69, 0x74, 0x6c, 
 0x65, 0x00, 0x00, 0x00, 0x20, 0x42, 0x00, 0x00, 0x50, 0x43, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 
 0x00, 0x00, 0x4d, 0x45, 0x54, 0x41, 0x3a, 0x74, 0x69, 0x74, 0x6c, 0x65, 0x00, 0x52, 0x7d, 0xfb, 
 0x77, 0x52, 0x54, 0x53, 0x43, 0x00, 0x01, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x03, 
 0x00, 0x00, 0x00, 0x55, 0x52, 0x4c, 0x00, 0x00, 0x80, 0x83, 0x43, 0x00, 0x80, 0x85, 0x43, 0x00, 
 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x4d, 0x45, 0x54, 0x41, 0x3a, 0x75, 0x72, 0x6c, 0x00, 
 0x52, 0x54, 0x5b, 0xe3, 0x52, 0x54, 0x53, 0x43, 0x00, 0x01, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 
 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x4b, 0x65, 0x79, 0x77, 0x6f, 0x72, 0x64, 0x73, 0x00, 0x00, 
 0x40, 0x08, 0x44, 0x00, 0x00, 0x02, 0x43, 0x00, 0x00, 0x00, 0x00, 0x09, 0x00, 0x00, 0x00, 0x4d, 
 0x45, 0x54, 0x41, 0x3a, 0x6b, 0x65, 0x79, 0x77, 0x00, 0x52, 0xdc, 0xf3, 0xdb, 0x52, 0x54, 0x53, 
 0x43, 0x00, 0x01, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x4d, 
 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x00, 0x00, 0x80, 0x2c, 0x44, 0x00, 0x00, 0x16, 0x43, 
 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x5f, 0x73, 0x74, 0x61, 0x74, 0x2f, 0x6d, 0x6f, 
 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x00, 0x45, 0x6d, 0x4b, 0x5d, 0x45, 0x4d, 0x49, 0x54, 0x01, 
 0x00, 0x52, 0x56, 0xf2, 0x4f, 0x15, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x47, 0x6f, 0x6f, 
 0x67, 0x6c, 0x65, 0x20, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x00, 0x00, 0xc0, 0x55, 0x44, 0x00, 0x00, 
 0x70, 0x41, 0x01, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x47, 0x4f, 0x4f, 0x47, 0x4c, 0x45, 
 0x3a, 0x6f, 0x72, 0x64, 0x65, 0x72, 0x00, 0x47, 0xde, 0xef, 0xfc, 0x47, 0x4e, 0x4f, 0x4c, 0x00, 
 0x00 };*/
static uint8 template_1_attrs_11[] = {
 0x52, 0xf5, 0x5e, 0x6f, 0x0a, 0x00, 0x00, 0x00, 0x74, 0x73, 0x6c, 0x54, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x47, 0xde, 0xef, 0xfc, 0x47, 0x4e, 0x4f, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x01 };
struct attr_entry template_1_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-vnd.Be-queryTemplate") },
{ "_trk/qrystr", 'CSTR', SZSTR("((name==\"*[aA][nN][yY] [qQ][uU][eE][sS][tT][iI][oO][nN] [yY][oO][uU]\\'[dD] [lL][iI][kK][eE] [tT][oO] [aA][sS][kK] [gG][oO][oO][gG][lL][eE] ?*\")&&(BEOS:TYPE==\"application/x-vnd.Be-bookmark\"))") },
{ "_trk/queryDynamicDate", 'BOOL', 1, &template_1_attrs_1 },
{ "_trk/recentQuery", 'LONG', sizeof(int32), &template_1_attrs_2 },
{ "_trk/qryvol1", 'MSGG', SZTAB(template_1_attrs_3) },
{ "_trk/qryinitmime", 'CSTR', SZSTR("Bookmark") },
{ "_trk/qryinitmode", 'LONG', sizeof(int32), &template_1_attrs_4 },
{ "_trk/qrymoreoptions_le", 'RAWT', SZTAB(template_1_attrs_5) },
{ "_trk/qryinitstr", 'CSTR', SZSTR("Any question you'd like to ask google ?") },
{ "_trk/focusedView", 'CSTR', SZSTR("TextControl") },
{ "_trk/focusedSelEnd", 'LONG', sizeof(int32), &template_1_attrs_6 },
{ "_trk/focusedSelStart", 'LONG', sizeof(int32), &template_1_attrs_7 },
{ "_trk/xtpinfo_le", 'RAWT', SZTAB(template_1_attrs_8) },
{ "_trk/pinfo_le", 'RAWT', SZTAB(template_1_attrs_9) },
{ "_trk/columns_le", 'RAWT', SZTAB(folders_attrs_1)/*SZTAB(template_1_attrs_10)*/ },
{ "_trk/viewstate_le", 'RAWT', SZTAB(template_1_attrs_11) },
{ NULL, 0, 0, NULL } /* end of list */
};

static int32 text_attrs_1 = 0x0000FFFF;
static int32 text_attrs_2 = 0x00000000;
static uint8 text_attrs_3 = 1;
static uint8 text_attrs_4[] = {
 0x41, 0x6c, 0x69, 0x21, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
 0x53, 0x77, 0x69, 0x73, 0x37, 0x32, 0x31, 0x20, 0x42, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x52, 0x6f, 0x6d, 0x61, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x41, 0x60, 0x00, 0x00, 0x42, 0xb4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x28, 0x53, 0x77, 0x69, 0x73, 0x37, 0x32, 0x31, 0x20, 0x42, 0x54, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x52, 0x6f, 0x6d, 0x61, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x41, 0x60, 0x00, 0x00, 0x42, 0xb4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x53, 0x77, 0x69, 0x73, 0x37, 0x32, 0x31, 0x20,
 0x42, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x52, 0x6f, 0x6d, 0x61, 0x6e, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x60, 0x00, 0x00, 0x42, 0xb4, 0x00, 0x00,
 0x00, 0x00, 0xff, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2a, 0x53, 0x77, 0x69, 0x73,
 0x37, 0x32, 0x31, 0x20, 0x42, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x52, 0x6f, 0x6d, 0x61,
 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x60, 0x00, 0x00,
 0x42, 0xb4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x47,
 0x53, 0x77, 0x69, 0x73, 0x37, 0x32, 0x31, 0x20, 0x42, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x52, 0x6f, 0x6d, 0x61, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x41, 0x20, 0x00, 0x00, 0x42, 0xb4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00 };
struct attr_entry text_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("text/plain") },
{ "be:encoding", 'LONG', sizeof(int32), &text_attrs_1 },
{ "alignment", 'LONG', sizeof(int32), &text_attrs_2 },
{ "wrap", 'BOOL', sizeof(uint8), &text_attrs_3 },
{ "styles", 'RAWT', SZTAB(text_attrs_4) },
{ NULL, 0, 0, NULL } /* end of list */
};

char *readmestr = \
"Welcome to the Google™ FileSystem for BeOS™, Zeta™ and Haiku™.\n"
"Copyright© 2004-2008, François Revol.\n"
"Google is a trademark of Google, Inc.\n"
"BeOS is a trademark of ACCESS.\n"
"Zeta is a trademark of yellowTAB GmbH.\n"
"Haiku is a trademark of Haiku, Inc.\n"
"\n"
"Use \"Search Google\" query template in this folder to ask google anything.\n"
"\n";

struct attr_entry mailto_me_bookmark_attrs[] = {
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-person") },
{ "META:email", 'CSTR', SZSTR("revol@free.fr") },
{ "META:name", 'CSTR', SZSTR("François Revol") },
{ "META:country", 'CSTR', SZSTR("France") },
{ "META:nickname", 'CSTR', SZSTR("mmu_man") },
//{ "META:company", 'CSTR', SZSTR("yellowTAB GmbH") },
{ "META:url", 'CSTR', SZSTR("http://revolf.free.fr/") },
{ "META:group", 'CSTR', SZSTR("") },
{ "IM:connections", 'CSTR', SZSTR("icq:77792625;gtalk:revolf@gmail.com;yahoo:mmu_man;msn:revol@mail.com") },
#if 0
{ "BEOS:TYPE", /*B_MIME_STRING_TYPE*/'MIMS', SZSTR("application/x-vnd.Be-bookmark") },
{ "META:title", 'CSTR', SZSTR("Report googlefs bugs") },
{ "META:url", 'CSTR', SZSTR("mailto:revol@free.fr"/*"&subject=googlefs bug report""&body=Hi, I found a bug in GoogleFS."*/) },
{ "META:keyw", 'CSTR', SZSTR("googlefs") },
//{ "GOOGLE:order", 'LONG', sizeof(int32), &fake_bm_attr_1 },
#endif
{ NULL, 0, 0, NULL } /* end of list */
};

#if 0
File:  Search Google a
Type              Size  Name                                Value                                                            
----------  ----------  ----------------------------------  -----------------------------------------------------------------
'MIMS'              35  "BEOS:TYPE"                         "application/x-vnd.Be-queryTemplate"                             
STRING             191  "_trk/qrystr"                       "((name==\"*[aA][nN][yY] [qQ][uU][eE][sS][tT][iI][oO][nN] [yY][o"
                                                            "O][uU]\\'[dD] [lL][iI][kK][eE] [tT][oO] [aA][sS][kK] [gG][oO][o"
                                                            "O][gG][lL][eE] ?*\")&&(BEOS:TYPE==\"application/x-vnd.Be-bookma"
                                                            "rk\"))"                                                         
BOOL                 1  "_trk/queryDynamicDate"             TRUE                                                             
INT32                4  "_trk/recentQuery"                  1 0x00000001                                                     
                                                            01 0F 47 4E 4F 4C 04 0C-63 72 65 61 74 69 6F 6E ..GNOL..creation 
                                                            44 61 74 65 51 EA C7 41-0F 47 4E 4C 4C 08 08 63 DateQ..A.GNLL..c 
                                                            61 70 61 63 69 74 79 00-00 00 00 00 00 00 00 0B apacity......... 
                                                            52 54 53 43 08 0A 64 65-76 69 63 65 4E 61 6D 65 RTSC..deviceName 
                                                            01 00 00 00 00 00 70 41-0B 52 54 53 43 10 0A 76 ......pA.RTSC..v 
                                                            6F 6C 75 6D 65 4E 61 6D-65 07 00 00 00 47 6F 6F olumeName....Goo 
                                                            67 6C 65 00 00 00 00 00-00 0B 52 54 53 43 10 07 gle.......RTSC.. 
                                                            66 73 68 4E 61 6D 65 09-00 00 00 67 6F 6F 67 6C fshName....googl 
                                                            65 66 73 00 00 00 00 00-                        efs.....         
STRING               9  "_trk/qryinitmime"                  "Bookmark"                                                       
INT32                4  "_trk/qryinitmode"                  1180858734 0x4662796E                                            
RAW                 36  "_trk/qrymoreoptions_le"            00 00 06 EC 00 00 00 00-01 00 00 00 00 00 00 00 ................ 
                                                            00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00 ................ 
                                                            00 00 00 00            -                        ....             
STRING              40  "_trk/qryinitstr"                   "Any question you'd like to ask google ?"                        
STRING              12  "_trk/focusedView"                  "TextControl"                                                    
INT32                4  "_trk/focusedSelEnd"                39 0x00000027                                                    
INT32                4  "_trk/focusedSelStart"              0 0x00000000                                                     
RAW                 60  "_trk/xtpinfo_le"                   FF FF FF FF 00 00 00 00-00 00 00 00 00 00 00 00 ................ 
                                                            00 00 00 00 00 00 00 00-00 00 00 00 01 00 00 00 ................ 
                                                            00 00 82 43 00 00 A0 42-00 00 00 00 00 00 00 00 ...C...B........ 
                                                            00 E0 9F 44 00 C0 7F 44-FF FF FF FF             ...D...D....     
#endif
#if 0
, 0x41, 0x6E, 0x79, 0x20, 0x71, 0x75, 0x65, 0x73-74, 0x69, 0x6F, 0x6E, 0x20, 0x79, 0x6F, 0x75
, 0x27, 0x64, 0x20, 0x6C, 0x69, 0x6B, 0x65, 0x20-74, 0x6F, 0x20, 0x61, 0x73, 0x6B, 0x20, 0x67
, 0x6F, 0x6F, 0x67, 0x6C, 0x65, 0x20, 0x3F, 0x00-, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x
, 0x54, 0x65, 0x78, 0x74, 0x43, 0x6F, 0x6E, 0x74-72, 0x6F, 0x6C, 0x00, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x
, 0x27, 0x00, 0x00, 0x00, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x-, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x
, 0x00, 0x00, 0x00, 0x00, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x-, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x
#endif
